	
.text

/*
 *      Vector table. This is used for initial platform startup.
 *      These vectors are to catch any un-intended traps.
 */

_vectors:

.long   0x00000000, _start
#if 1
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault

.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault

.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault

.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault, _fault
.long   _fault, _fault, _fault, _fault, _fault, _fault, _fault


/*
 *      The very last vector position is stolen to use as a version
 *      number for this boot code :-)
 */

_version:
.long   0x01000000
#endif
	
/*****************************************************************************/


/*
 *      This is the initial start up entry point.
 */

_start:
        nop
        move.w #0x2700,%sr
	
	/* Vector Base Register setup */
	move.l #_vectors,%d0
	move.c %d0,%VBR

	/* Register file setup */
	move.l #0x10000001,%d0
	move.c %d0,%MBAR

	/* SRAM setup */
	move.l #0x20000001,%d0
	move.c %d0,%RAMBAR0

#if 0
	move.l #0x10000000,%a0
	moveq #0x20,%d0
	move.l %d0,%a0@(68)
#endif
		
	/* setup inital stackpointer */	
	move.l #0x20001000,%sp
	
	/* Disable Cache */
        move.l #0x01000000, %d0
	move.c %d0,%CACR
	clr.l %d0
	move.c %d0,%ACR0
	move.c %d0,%ACR1	

	jsr board_init
	
	/* setup final stackpointer */
	lea 0x100000,%sp

	jmp start_main

	.globl	wait
wait:
	move.l %sp@(4),%d0
1:	subq.l #1,%d0
	bne 1b
	rts
	
	.globl	enablecache
enablecache:
        move.l  #0x01000000, %d0                // Invalidate entire cache
        movec   %d0, %CACR
        move.l  #0x0000c000, %d0                /* Setup cache mask */
        movec   %d0, %ACR0                      /* Enable cache */
        move.l  #0xff00c000, %d0                /* Setup cache mask */
        movec   %d0, %ACR1                      /* Enable cache */
        move.l  #0x80000100, %d0
        movec   %d0, %CACR
	
        rts

	
_fault:
	jmp _fault
	
	.globl	call
call:
	move.l %sp@(4),%a0
	jmp (%a0)
