
MEMORY {
	flash	: ORIGIN = 0xffe00000, LENGTH = 0x00004000
	ram	: ORIGIN = 0x00000400, LENGTH = 0x0000fc00
}

SECTIONS {

        .text : {
		_stext = . ;
        	*(.text)
		*(.rodata)
		. = ALIGN(4);
		_etext = . ;
        } > flash

	.data : AT(_etext) {
		_sdata = . ;
		*(.data)
		. = ALIGN(4);
		_edata = . ;
	} > ram

	.bss : {
		_sbss = . ;
		*(.bss)	
		*(COMMON)
		. = ALIGN(4);
		_ebss = . ;	
	} > ram
}

